##############################
# Noesis importer
##############################
# v1.0.1


from inc_noesis import *

import noesis
import rapi
import os
import hashlib
import json
import sys
import glob

#from ctypes import *
#import noewin

# Add addon dir to system modules directory
sys.path.append(os.path.dirname(__file__))

import nrfile
import nrtools
import nrdump
import nrnoeimp

#----------------------
# Global settings
#----------------------
# Projection matrix 
#g_mvp = [[1.20635,0,0,0],[0,2.14462,0,0], [0,0,-1.00001,-1],[0,0,-0.100001,0]]


def isNoeWinAvailable():
    res = False
    try:
        import noewin
        res = True
    except Exception as e:
        res = False
    return res


def registerNoesisTypes():
    noesis.logPopup()
    
    noesis.setDataViewerSetting("Hidden items in shellview", "1")

    handle = noesis.register("NinjaRipper 2", ".nr")
    noesis.setHandlerTypeCheck(handle, nrCheckType)
    noesis.setHandlerLoadModel(handle, nrLoadModel)

    if isNoeWinAvailable():
        import nrnoegui
        handle = noesis.registerTool("&Ninja Ripper 2 World Space Import", nrnoegui.ninjaRipperImporterGuiMethod)
        handle = noesis.registerTool("&Ninja Ripper 2 Local Space Import", nrnoegui.ninjaRipperImporterGuiMethodLocalSpace)
    return 1


def nrCheckType(data):
    if len(data) < 8:
        return 0

    bs = NoeBitStream(data)
    if bs.readUInt() != nrfile.getNrMagic():
        return 0

    return 1


def nrLoadModel(data, mdlList):
    ctx = rapi.rpgCreateContext()

    filename = rapi.getInputName()
    #fileDirectory = os.path.dirname(os.path.abspath(filename))
    #print("Ninja Ripper 2 file: " + filename)

    # Prepare options
    options = nrnoeimp.getImportOptions()
    options['fileName'] = filename

    imp = nrnoeimp.NoesisImporter()

    print(options)  ##############################

    if options['importType'] == 'world':
        print("ռ䵼")
        imp.importPostVs(filename, options, mdlList)
    elif options['importType'] == 'local':
        print("ֲռ䵼")
        imp.importPreVs(filename, options, mdlList)

    return 1
